#include <iostream>  
#include <assert.h>
using namespace std;

// void foo(int &z)  when this is pass by reference, we get, via z, a loan of the adddress of z.
void foo(int z) // this makes a local copy of the value a.
{
	int w = 2 * z;

	int *p = &w;

	cout << "z = " << z << endl;
	cout << "&z = " << &z << endl;
	cout << "w = " << w << endl;
	cout << "&w = " << &w << endl;
	cout << "p = " << p << endl;
	cout << "*p = " << *p << endl;
	cout << "&p = " << &p << endl;
}


int main(int argc, char **argv)
{

	int a = 5;
	cout << "a = " << a << endl;
	cout << "&a = " << &a << endl;
	foo(a);
	return 0;
}


